class CreateEngines < ActiveRecord::Migration
    def self.up
      create_table :engines do |e|
        e.string     :name
        e.column     :engine_conf, :json
        e.integer    :application_id
        e.boolean    :deleted, :default => false
        e.timestamps
      end
      add_index :engines, :application_id
    end

    def self.down
        drop_table :engines
    end

end

CreateEngines.down if ActiveRecord::Base.connection.table_exists? 'engines'
CreateEngines.up
