
require 'active_record'
require 'rest-client'
require_relative 'user'
require_relative 'engine'
require_relative 'config'


class Application < ActiveRecord::Base
  attr_accessor :api_key_to_update


  validates_presence_of   :name, :api_key, :url
  validates_uniqueness_of :api_key, :url
  validates_uniqueness_of :name, :scope => :user_id
  has_many                :engines
  belongs_to              :user


  after_save    :save_app
 # before_update :save_status
 # after_update  :update_app

  private

  def save_status
      @api_key_to_update  = api_key
  end

  def save_app
      option  = {user: false,app: true}
      to_save = {api_key: api_key}.to_json
      RestClient.post("#{AUTH_MANAGER_URI}auth_manager/adder/save",{object: to_save,option: option})
  end

  def update_app
      option  = {user: false,app: true}
      old_obj = {api_key: @api_key_to_update}.to_json
      to_update = {api_key: api_key}.to_json
      if deleted == false
        RestClient.put("#{AUTH_MANAGER_URI}auth_manager/updater/update",{object: to_update,old_object: old_obj,option: option})
      else
        RestClient.delete("#{AUTH_MANAGER_URI}auth_manager/deleter/delete",{object: to_update,option: option})
      end
  end

end
