require 'active_record'
require 'auth_manager'
require 'json'
require 'rest-client'
require_relative 'application'
require_relative 'config'

class User < ActiveRecord::Base
 
  attr_accessor :login_to_update, :passwd_to_update

  validates_presence_of   :login, :password, :email
  validates_uniqueness_of :login, :email
  has_many                :applications, dependent: :destroy

  after_save    :save_user
 # before_update :save_status
 # after_update  :update_user

  private 

  def save_status
      @login_to_update  = login
      @passwd_to_update = password
  end

  def save_user
      option  = {user: true,app: false}
      to_save = {login: login,password: password}.to_json
      RestClient.post("#{AUTH_MANAGER_URI}auth_manager/adder/save",{object: to_save,option: option})  
  end

  def update_user
      option  = {user: true,app: false}
      old_obj = {login: @login_to_update,password: @passwd_to_update}.to_json
      to_update = {login: login,password: password}.to_json
      if deleted == false
        RestClient.put("#{AUTH_MANAGER_URI}auth_manager/updater/update",{object: to_update,old_object: old_obj,option: option})       
      else
        RestClient.delete("#{AUTH_MANAGER_URI}auth_manager/deleter/delete",{object: to_update,option: option})   
      end
  end

end
